(function () {
    "use strict";

    angular.module('core').controller('parcelaCartaoReceberController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'cartaoReceberService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, cartaoReceberService, lookupService) {
        $scope.initializeLayout('Parcelas de Cartões a Receber');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
            totais: {
                ValorOriginal: null,
                ValorEmAberto: null,
                ValorLiquidado: null,
                ValorAbatido: null,
                ValorTaxa: null,
            },
        };
        $scope.popups = {
            /* add a entidade é CartaoReceber. */
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    cartaoReceberService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.refresh();

                                if (action == $scope.popups.add.saveAction.saveAndNew) {
                                    $scope.popups.add.toggle();
                                }
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                saveAction: { save: 0, saveAndNew: 1 },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.steps.index = 0;
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    cartaoReceberService
                        .prepareNew()
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.add.data = response.Data;
                                $scope.popups.add.ativo = true;
                                $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                steps: {
                    index: 0,
                    count: 3,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            },
            /* edit a entidade é ParcelaCartaoReceber. */
            edit: {
                ativo: false,
                data: {},
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.get(id);
                    }
                },
                get: function (id) {
                    cartaoReceberService
                        .getParcelaCartaoReceber(id)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                                $scope.popups.edit.ativo = false;
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.edit.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.popups.edit.ativo = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                save: function () {
                    $scope.state.salvando = true;
                    cartaoReceberService
                        .saveParcelaCartaoReceber($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                delete: function () {
                    $scope.state.salvando = true;
                    cartaoReceberService
                        .deleteParcelaCartaoReceber($scope.popups.edit.data.ID)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.ativo = false;
                                $scope.popups.edit.data = {};
                                $scope.refresh();
                            }
                            $scope.state.salvando = false;
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepare: function () {
                    cartaoReceberService
                        .prepareParcelaCartaoReceber($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.edit.ativo = true;
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepareNewLiquidacao: function () {
                    cartaoReceberService
                        .prepareNewLiquidacaoCartaoReceber($scope.popups.edit.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $alert({ title: $scope.Title, text: response.Message });
                            } else {
                                $scope.popups.edit.data = response.Data;
                                $scope.popups.liquidacao.select($scope.popups.edit.data.Liquidacoes.length - 1);
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                tabs: { current: 0, liquidacoes: 0, detalhes: 1, cartao: 2 },
            },
            /* liquidação a entidade é LiquidacaoCartaoReceber */
            liquidacao: {
                index: -1,
                data: null,
                select: function (index) {
                    $scope.popups.liquidacao.index = index;
                    $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[index];

                    $timeout(function () { $('[ng-model*="popups.liquidacao.data.Data"]').focus(); });
                },
                toggle: function () {
                    if ($scope.popups.liquidacao.index < 0) {
                        $scope.popups.liquidacao.index = 0;
                        $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                    } else {
                        $scope.popups.edit.prepare();
                        $scope.popups.liquidacao.index = -1;
                        $scope.popups.liquidacao.data = null;
                    }
                },
                next: function () {
                    if ($scope.popups.liquidacao.index < $scope.popups.edit.data.Liquidacoes.length - 1) {
                        $scope.popups.liquidacao.index++;
                        $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                    }
                },
                prior: function () {
                    if ($scope.popups.liquidacao.index > 0)
                        $scope.popups.liquidacao.index--;

                    $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                },
            },
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            consumidor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllConsumidor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            bandeiraCartao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllBandeiraCartao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            categoriaFinanceira: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCategoriaReceber({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            subcategoriaFinanceira: {
                lookup: function (chaves) {
                    var filtro = { CategoriaSuperior: { ID: null } };
                    if ($scope.popups.add.ativo && $scope.popups.add.data.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.add.data.Categoria.ID;
                    }
                    if ($scope.popups.edit.ativo && $scope.popups.add.data.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.edit.data.Categoria.ID;
                    }
                    return $q.when(
                        lookupService
                            .getAllSubcategoriaReceber({ chaves: chaves, filtro: filtro })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contaAnalitica: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaAnalitica({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contaCorrente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaContabil({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            rateioCentroCusto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllRateioCentroCusto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            $scope.refresh();

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.filtro.args.sortExpression = 'CriadoEm DESC, Codigo';
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            cartaoReceberService
                .getAllParcelaCartaoReceber($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };
        $scope.count = function () {
            cartaoReceberService
                .countParcelaCartaoReceber($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.count = response.Data;
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                }
                );
        };
        $scope.totalize = function () {
            cartaoReceberService
                .totalizeParcelaCartaoReceber($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.totais = response.Data;
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            $scope.state.carregandoMais = true;
            cartaoReceberService
                .getAllParcelaCartaoReceber($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                    $scope.state.carregandoMais = false;
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    $scope.state.carregandoMais = false;
                });
        };

        $scope.refresh = function () {
            $scope.state.filtro.ativo = false;
            $scope.getAll();
            $scope.count();
            $scope.totalize();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                sortExpression: '',
                skip: 0,
                take: 20
            };
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();